/*  The Librarian

    Copyright © 2005 Debarshi Ray

    This file is part of 'The Librarian'.

    'The Librarian' is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    'The Librarian' is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with 'The Librarian'; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 

    Written by: Debarshi Ray <debarshi.ray@gmail.com>
*/


#include "Librarian.h"

extern GtkWidget *application_window;
extern MYSQL *connection;

MYSQL_RES* MySQLQuery(char *query,gboolean retrieve)
 {
  gchar *buffer;

   if(mysql_query(connection,query))
    {
     buffer = (gchar *) malloc(sizeof(char)*1024);
     sprintf(buffer,"Query failure: \"%s\".\nError %d: %s.",query,mysql_errno(connection),mysql_error(connection));
     ShowMessage(GTK_WINDOW(application_window),buffer,GTK_MESSAGE_ERROR);
     free(buffer);
     return NULL;
    }
   else if(retrieve)
     return mysql_use_result(connection);

  return !NULL; 
 }

int MySQLServerConnect(char *username,char *password,char *hostname)
 {
  gchar buffer[128];
  connection = mysql_init(NULL);

   if(!mysql_real_connect(connection,hostname,username,password,"Library",0,NULL,0))
    {
     sprintf(buffer,"Connection failed.\nConnection error %d: %s.",mysql_errno(connection),mysql_error(connection));
     ShowMessage(GTK_WINDOW(application_window),buffer,GTK_MESSAGE_ERROR);
     return 1;
    }
   if(mysql_select_db(connection,"Library"))
    {
     sprintf(buffer,"Could not use database.\nDatabase usage error %d: %s.",mysql_errno(connection),mysql_error(connection));
     ShowMessage(GTK_WINDOW(application_window),buffer,GTK_MESSAGE_ERROR);
     return 2;
    }

  return 0;
 }

void MySQLServerDisconnect(void)
 {
  mysql_close(connection);
 }
