/*  The Librarian

    Copyright © 2005 Debarshi Ray

    This file is part of 'The Librarian'.

    'The Librarian' is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    'The Librarian' is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with 'The Librarian'; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA 

    Written by: Debarshi Ray <debarshi.ray@gmail.com>
*/


#include "Librarian.h"

extern struct FindDialog find_entry;

void add_widget_with_label(GtkBox *box,gchar *caption,GtkWidget *widget)
{
  GtkWidget *label = gtk_label_new(caption);
  GtkWidget *hbox = gtk_hbox_new(TRUE,4);

  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX(hbox),widget,TRUE,TRUE,1);
  gtk_box_pack_start(box,hbox,TRUE,FALSE,1);

  return;
}

void Initialize(void)
 {
  FILE *universal_file;
  struct UniversalRecord universal_record = {0,0};

   if((universal_file = fopen(UniversalFile,"rb")) == NULL)
    {
      if((universal_file = fopen(UniversalFile,"wb")) != NULL)
       {
        fwrite((void*)&universal_record,sizeof(struct UniversalRecord),1,universal_file);
        fclose(universal_file);
       }
    }

  find_entry.match_case = FALSE;
  find_entry.match_entire_word_only = FALSE;
  find_entry.search_string[0] = '\0';

  printf("Glib version: %d.%d.%d\n",GLIB_MAJOR_VERSION,GLIB_MINOR_VERSION,GLIB_MICRO_VERSION);
  printf("GTK+ version: %d.%d.%d\n",GTK_MAJOR_VERSION,GTK_MINOR_VERSION,GTK_MICRO_VERSION);

  return;
 }

void** Malloc2D(long rows,long columns,size_t size)
 {
  int i;
  void **array;

  array = (void**) malloc(sizeof(void*)*rows);
   for(i=0;i<rows;++i)
     array[i] = malloc(size*columns);

  return array;
 }

gboolean searchstr(gchar *s1,gchar *s2,gboolean within,int (*compare)(const char*,const char*,size_t))
 {
  int i,l1=strlen(s1),l2=strlen(s2),diff=l1-l2+1;

   if(within)
    {
      for(i=0;i<diff;++i)
       {
         if((*compare)(s1+i,s2,l2) == 0)
           return TRUE;
       }
    }
   else if((*compare)(s1,s2,l1) == 0)
     return TRUE;

  return FALSE;
 }
